#include <iostream>
#include <fstream>
#include <map>
#include <vector>

#include <stdlib.h>

#include <unistd.h>

#include <pthread.h>

#include "define.h"

using namespace std;

#ifndef FUNCTIONS_H
#define FUNCTIONS_H

struct Argument{
       
       int begin;       
       
       int filen;
       
       };

void Init(){
     
     if (_thread > sysconf(_SC_NPROCESSORS_CONF))
        _thread = sysconf(_SC_NPROCESSORS_CONF);
     
     if (_thread < 1)
        _thread = 1;
     
     if (inprimer.size() > 0)
        primer_count = Input_primers();  
                             
     //Print the info
     cout << Name << endl;
     cout << "Version : " << Version << endl;
     cout << "Thread number : " << _thread << endl;
     
     //Input
     if (_in_pair)
     
        Input_reads_pair(infilename_1, infilename_2, extqualname_1, extqualname_2, seq_pairs, order, _single_input);
     
     else 
          Input_reads(infilename_1, extqualname_1, seq_pairs, order);
     
     //cout << seqs_1.size() << endl;
     //cout << seqs_2.size() << endl;
               
     }

void Trim(){
    
    //seq_1
    for (hash_map <string, Seq_pair, std_string_hash>::iterator iter = seq_pairs.begin(); iter != seq_pairs.end(); iter ++){
        
        if (_trim_end > 0)
           iter->second.Trim(_trim_begin, _trim_end);
        
        if (_trim_qual > 0)
           iter->second.Qual_trim(_trim_qual, _trim_p);
        
        if (_gc_p_min > 0)
           iter->second.GC_trim(_gc_p_min, _gc_p_max);
        
        if (primer_count > 0)               
           iter->second.Primer_trim(primers, primer_count);
        }        
    
    return;
    }

void * Trim_parallel(void * args){
               
     int begin;
     
     int filen;
     
     int count;
     
     hash_map <string, Seq_pair, std_string_hash>::iterator iter;
     
     //seqs_1
     
     begin = ((Argument *) args)->begin;
     
     filen = ((Argument *) args)->filen;
     
     count = 0;
     
     if (begin >= seq_pairs.size())
     
           pthread_exit(0);
     
     iter  = seq_pairs.begin();
     
     for (int i = 0; i < begin; i++)
         if (iter != seq_pairs.end())
                  iter ++;
     
     while ((count < filen) && (iter != seq_pairs.end())){
           
           //cout << begin / filen << endl;
           
           if (_trim_end > 0)
              iter->second.Trim(_trim_begin, _trim_end);
        
           if (_trim_qual > 0)
              iter->second.Qual_trim(_trim_qual, _trim_p);
              
           if (_gc_p_min > 0)
              iter->second.GC_trim(_gc_p_min, _gc_p_max);
           
           if (primer_count > 0)        
              iter->second.Primer_trim(primers, primer_count);
        
           
           count ++;
           
           iter ++;
           
           }
                     
     pthread_exit(0);
     
     }

void Drop_dup(){
    
    hash_set <string, std_string_hash> hash_1;
    hash_set <string, std_string_hash> hash_2;
    
    for (hash_map <string, Seq_pair, std_string_hash>::iterator iter = seq_pairs.begin(); iter != seq_pairs.end(); iter ++){
       
        if (iter->second.Get_seq_1().Is_seq){
        
           if (hash_1.count(iter->second.Get_seq_1().Get_seq()) == 0)
                                                  hash_1.insert(iter->second.Get_seq_1().Get_seq());
           else 
                iter->second.Set_dup_1();
                           
           }           
        
        if (iter->second.Get_seq_2().Is_seq){
        
           if (hash_2.count(iter->second.Get_seq_2().Get_seq()) == 0)
                                                  hash_2.insert(iter->second.Get_seq_2().Get_seq());
           else 
                iter->second.Set_dup_2();
                                
           }
        }
    }

void * Drop_dup_1(void *){
     
     hash_set <string, std_string_hash> hash;
     
     for (hash_map <string, Seq_pair, std_string_hash>::iterator iter = seq_pairs.begin(); iter != seq_pairs.end(); iter ++)
        
        if (iter->second.Get_seq_1().Is_seq){
        
           if (hash.count(iter->second.Get_seq_1().Get_seq()) == 0)
                                                  hash.insert(iter->second.Get_seq_1().Get_seq());
           else 
                iter->second.Set_dup_1();
           
           }
     
     pthread_exit(0);
     
     }

void * Drop_dup_2(void *){
     
     hash_set <string, std_string_hash> hash;
     
     for (hash_map <string, Seq_pair, std_string_hash>::iterator iter = seq_pairs.begin(); iter != seq_pairs.end(); iter ++)
        
        if (iter->second.Get_seq_2().Is_seq){
        
           if (hash.count(iter->second.Get_seq_2().Get_seq()) == 0)
                                                  hash.insert(iter->second.Get_seq_2().Get_seq());
           else 
                iter->second.Set_dup_2();
           
           }
     
     pthread_exit(0);
     
     }

#endif
