#include <iostream>
#include <vector>

#include <stdlib.h>

#include "seq_pair.h"
#include "define.h"
#include "version.h"
//#include "default_primers.h"

using namespace std;

#ifndef IO_H
#define IO_H

void Output_analysis_report(unsigned int qual_count_1, unsigned int primer_count_1, unsigned int gc_count_1, unsigned int dup_count_1, unsigned int out_count_1,
                            unsigned int qual_count_2, unsigned int primer_count_2, unsigned int gc_count_2, unsigned int dup_count_2, unsigned int out_count_2){
                            
                            string reportname = outfilename + "/analysis_report.txt";
                            
                            ofstream out(reportname.c_str(), ofstream::out);
                            if (!out){
                                      
                                      cerr << "Open analysis report error : " << reportname << endl;
                                      exit(0);
                                      
                                      }
                            
                            out << Name << endl;
                            out << "Version : " << Version << endl;
                            
                            out << "Input file : " << infilename_1;
                            if(!_single_input) 
                                 out << " " << infilename_2;
                            
                            out << endl;   
                            
                            out << "Input format : ";
                            if (_in_format)
                                        out << "FASTQ" << endl;
                            else 
                                 out << "FASTA" << endl;
                            
                            if (_ext_qual) 
                               out << "Quality file : " << extqualname_1 << " " << extqualname_2 << endl;
                            
                            out << "If Pair ended : ";
                            
                            if (_in_pair){
                                          out << "Yes" << endl;
                                          
                                          out << "If Keep pair : ";
                                          if (_keep_pair)
                                                         out << "Yes" << endl;
                                          else 
                                               out << "No" << endl;
                                          }
                            else
                                out << "No" << endl;
                                                                                                                
                            out << "Output format : ";
                            if (_out_format)
                                        out << "FASTQ" << endl;
                            else 
                                 out << "FASTA" << endl;
                            
                            
                            out << "Base Trim : " << _trim_begin + 1 << " " << _trim_end + 1 << endl;
                            out << "Quality Trim : " << _trim_qual_orig << " " << _trim_p << " ";
                            if (_trim_qual_format)
                               out << "Sanger";
                            else
                                out << "Phred";
                            out << endl;                                
                            out << "Tag sequences : " << inprimer << endl;
                            out << "Tag sequence number : " << primer_count << endl;
                            out << "GC proportion : " << _gc_p_min << " ~ " << _gc_p_max << endl;
                            
                            out << "#Reads 1" << endl;
                            out << "Total Number : " << seq_pairs.size() << endl;                            
                            out << "Quality Trim number : " << qual_count_1 << endl;
                            out << "Tag Sequence Trim number : " << primer_count_1 << endl;
                            out << "GC Trim number : " << gc_count_1 << endl;
                            out << "Duplication Trim number : " << dup_count_1 << endl;
                            out << "Output number : " << out_count_1 << endl;                            
                            
                            if (dup_count_2 != -1){
                                            
                            out << "#Reads 2" << endl;
                            out << "Total Number : " << seq_pairs.size() << endl;                            
                            out << "Quality Trim number : " << qual_count_2 << endl;
                            out << "Tag Sequence Trim number : " << primer_count_2 << endl;
                            out << "GC Trim number : " << gc_count_2 << endl;
                            out << "Duplication Trim number : " << dup_count_2 << endl;                                                                                                                                                                                                                                            
                            out << "Output number : " << out_count_2 << endl;
                            
                            }
                            
                            out.close();
                            out.clear();     
     
     }



void Output_reads_pair(){
                       
    unsigned int qual_count_1 = 0;
    unsigned int qual_count_2 = 0;
    
    unsigned int primer_count_1 = 0;
    unsigned int primer_count_2 = 0;
    
    unsigned int gc_count_1 = 0;
    unsigned int gc_count_2 = 0;
    
    unsigned int dup_count_1 = 0;
    unsigned int dup_count_2 = 0;
    
    unsigned int out_count_1 = 0;
    unsigned int out_count_2 = 0;
    
    if (_keep_pair){
                    
                    dup_count_2 = -1;
                    qual_count_2 = -1;                    
                    primer_count_2 = -1;
                    gc_count_2 = -1;
                    out_count_2 = -1; 
                                        
                    }
    
    string out_surffix = ".fastq";
    
    if (!_out_format) out_surffix = ".fasta";
    
    string outfilename_1 = outfilename + "/read-1" + out_surffix;
    string outfilename_2 = outfilename + "/read-2" + out_surffix;  
    
    string qualfilename_1 = outfilename + "/trim-qual-1" + out_surffix;
    string qualfilename_2 = outfilename + "/trim-qual-2" + out_surffix;
    
    string primerfilename_1 = outfilename + "/trim-primer-1" + out_surffix;
    string primerfilename_2 = outfilename + "/trim-primer-2" + out_surffix;
    
    string gcfilename_1 = outfilename + "/trim-gc-1" + out_surffix;
    string gcfilename_2 = outfilename + "/trim-gc-2" + out_surffix;
    
    string dupfilename_1 = outfilename + "/trim-dup-1" + out_surffix;
    string dupfilename_2 = outfilename + "/trim-dup-2" + out_surffix;
                        
    //output
    ofstream outfile_1(outfilename_1.c_str(), ofstream::out);
    if (!outfile_1){
                   
                   cerr << "Error : Open output file error : " << outfilename_1 << endl;
                   exit(0);
                   
                   }
    
    ofstream outfile_2(outfilename_2.c_str(), ofstream::out);
    if (!outfile_2){
                   
                   cerr << "Error : Open output file error : " << outfilename_2 << endl;
                   exit(0);
                   
                   }
    //qual
    ofstream qual_1(qualfilename_1.c_str(), ofstream::out);
    if (!qual_1){
                 
                 cerr << "Waring : Open qual file error : " << qualfilename_1 << endl;
                                  
                 }
                 
    ofstream qual_2(qualfilename_2.c_str(), ofstream::out);
    if (!qual_2){
                 
                 cerr << "Waring : Open qual file error : " << qualfilename_2 << endl;
                                  
                 }
    //primer
    ofstream primer_1(primerfilename_1.c_str(), ofstream::out);
    if (!primer_1){
                 
                 cerr << "Waring : Open primer file error : " << primerfilename_1 << endl;
                                  
                 }
                 
    ofstream primer_2(primerfilename_2.c_str(), ofstream::out);
    if (!primer_2){
                 
                 cerr << "Waring : Open primer file error : " << primerfilename_2 << endl;
                                  
                 }
   
   //gc
    ofstream gc_1(gcfilename_1.c_str(), ofstream::out);
    if (!gc_1){
                 
                 cerr << "Waring : Open gc file error : " << gcfilename_1 << endl;
                                  
                 }
                 
    ofstream gc_2(gcfilename_2.c_str(), ofstream::out);
    if (!gc_2){
                 
                 cerr << "Waring : Open gc file error : " << gcfilename_2 << endl;
                                  
                 }  
   
   //dup
   ofstream dup_1(dupfilename_1.c_str(), ofstream::out);
    if (!dup_1){
                 
                 cerr << "Waring : Open dup file error : " << dupfilename_1 << endl;
                                  
                 }
                 
    ofstream dup_2(dupfilename_2.c_str(), ofstream::out);
    if (!dup_2){
                 
                 cerr << "Waring : Open dup file error : " << dupfilename_2 << endl;
                                  
                 } 
    
                                                                                             
    for(vector <string> ::iterator viter = order.begin(); viter != order.end(); viter ++){
                          
                  string label = *viter;
                  
                  if (seq_pairs.count(label)== 0){
                                             
                                             cerr << "Waring : ID " << label << " Cannot be found" << endl;
                                             
                                             }
                          
                  Seq_pair seq_pair = seq_pairs[label];                                                   
                  
                  ostream * out_1;
                  ostream * out_2; 
                          
                  if (_keep_pair){                                                                                                                             
                                                    
                          if (seq_pair.Is_qual_trim()) {
                                                       qual_count_1 ++;
                                                       out_1 = & qual_1;
                                                       out_2 = & qual_2;
                                                       }
                                                       
                          else if (seq_pair.Is_primer_trim()) {
                                                         primer_count_1 ++;
                                                         out_1 = & primer_1;
                                                         out_2 = & primer_2;
                                                         }
                                                         
                          else if (seq_pair.Is_gc_trim()) {
                                                         gc_count_1 ++;
                                                         out_1 = & gc_1;
                                                         out_2 = & gc_2;
                                                         }
                          
                          else if (seq_pair.Is_dup_trim()) {
                                                      dup_count_1 ++;
                                                      out_1 = & dup_1;
                                                      out_2 = & dup_2;
                                                      }
                                                                                                                    
                          else if (seq_pair.Is_seq()){
                                       
                                       out_count_1 ++;                                       
                                       out_1 = & outfile_1;
                                       out_2 = & outfile_2;
                                       }
                                            
                              }                
    
                    else {
    
                      //seq_1                     
                      if (seq_pair.Get_seq_1().Is_qual_trim())  {
                                                                qual_count_1 ++;
                                                                out_1 = & qual_1;                                                                
                                                                }
                                                                
                      else if (seq_pair.Get_seq_1().Is_primer_trim()) {
                                                                 primer_count_1 ++;
                                                                 out_1 = & primer_1;                                                                 
                                                                 }
                                                                 
                      else if (seq_pair.Get_seq_1().Is_gc_trim()) {
                                                                 gc_count_1 ++;
                                                                 out_1 = & gc_1;                                                                 
                                                                 }                                                                 
                                                                 
                      else if (seq_pair.Get_seq_1().Is_dup_trim())   {
                                                                dup_count_1 ++;
                                                                out_1 = & dup_1;
                                                                }
                                            
                      else if (seq_pair.Get_seq_1().Is_seq){                                  
                                                       out_count_1 ++;
                                                       out_1 = & outfile_1;                                                       
                                                       }
                      
                       //seq_2                                  
                     
                                            
                      if (seq_pair.Get_seq_2().Is_qual_trim()){
                                                               qual_count_2 ++;
                                                               out_2 = & qual_2;
                                                               }
                                                               
                      else if (seq_pair.Get_seq_2().Is_primer_trim()){
                                                                 primer_count_2 ++;
                                                                 out_2 = & primer_2;
                                                                 }
                                                                 
                      else if (seq_pair.Get_seq_2().Is_gc_trim()){    
                                                                  gc_count_2 ++;
                                                                  out_2 = & gc_2;
                                                                  }
                                                                                                             
                      else if (seq_pair.Get_seq_2().Is_dup_trim()){    
                                                                  dup_count_2 ++;
                                                                  out_2 = & dup_2;
                                                                  }
                      
                      else if (seq_pair.Get_seq_2().Is_seq){
                                  
                                  out_count_2 ++;
                                  out_2 = & outfile_2;
                                  }
                      }            
                                                
                      
                      
                seq_pair.Out_put(label, out_1, out_2, _out_format);      
                       
         }
            
    outfile_1.close();
    outfile_1.clear();
    
    outfile_2.close();
    outfile_2.clear();
    
    qual_1.close();
    qual_1.clear();
    
    qual_2.close();
    qual_2.clear();
    
    primer_1.close();
    primer_1.clear();
    
    primer_2.close();
    primer_2.clear();
    
    dup_1.close();
    dup_1.clear();
    
    dup_2.close();
    dup_2.clear();
    
    
    Output_analysis_report(qual_count_1, primer_count_1, gc_count_1, dup_count_1, out_count_1, qual_count_2, primer_count_2, gc_count_2, dup_count_2, out_count_2);
    
    }

void Output_reads(){
                       
    unsigned int qual_count_1 = 0;
    
    unsigned int primer_count_1 = 0;
    
    unsigned int gc_count_1 = 0;
    
    unsigned int dup_count_1 = 0;
    
    unsigned int out_count_1 = 0;
    
    string out_surffix = ".fastq";
    
    if (!_out_format) out_surffix = ".fasta";
    
    string outfilename_1 = outfilename + "/read" + out_surffix;  
    
    string qualfilename_1 = outfilename + "/trim-qual" + out_surffix;
    
    string primerfilename_1 = outfilename + "/trim-primer" + out_surffix;
    
    string gcfilename_1 = outfilename + "/trim-gc" + out_surffix;
    
    string dupfilename_1 = outfilename + "/trim-dup" + out_surffix;
                        
    //output
    ofstream outfile_1(outfilename_1.c_str(), ofstream::out);
    if (!outfile_1){
                   
                   cerr << "Error : Open output file error : " << outfilename_1 << endl;
                   exit(0);
                   
                   }
    
    //qual
    ofstream qual_1(qualfilename_1.c_str(), ofstream::out);
    if (!qual_1){
                 
                 cerr << "Waring : Open qual file error : " << qualfilename_1 << endl;
                                  
                 }
    
    //primer
    ofstream primer_1(primerfilename_1.c_str(), ofstream::out);
    if (!primer_1){
                 
                 cerr << "Waring : Open primer file error : " << primerfilename_1 << endl;
                                  
                 }               
    //gc
    ofstream gc_1(gcfilename_1.c_str(), ofstream::out);
    if (!gc_1){
                 
                 cerr << "Waring : Open gc file error : " << gcfilename_1 << endl;
                                  
                 }
   //dup
   ofstream dup_1(dupfilename_1.c_str(), ofstream::out);
    if (!dup_1){
                 
                 cerr << "Waring : Open dup file error : " << dupfilename_1 << endl;
                                  
                 }
                 
    for(vector <string> ::iterator viter = order.begin(); viter != order.end(); viter ++){
                          
                  string label = *viter;
                          
                  Seq_pair seq_pair = seq_pairs[label];                                                   
                  
                  ostream * out_1;
                  
                  if (seq_pair.Get_seq_1().Is_qual_trim())  {
                                                                qual_count_1 ++;
                                                                out_1 = & qual_1;                                                                
                                                                }
                                                                
                      else if (seq_pair.Get_seq_1().Is_primer_trim()) {
                                                                 primer_count_1 ++;
                                                                 out_1 = & primer_1;                                                                 
                                                                 }
                      
                      else if (seq_pair.Get_seq_1().Is_gc_trim()) {
                                                                 gc_count_1 ++;
                                                                 out_1 = & gc_1;                                                                 
                                                                 }
                      
                      else if (seq_pair.Get_seq_1().Is_dup_trim())   {
                                                                dup_count_1 ++;
                                                                out_1 = & dup_1;
                                                                }
                                            
                      else if (seq_pair.Get_seq_1().Is_seq){                                  
                                                       out_count_1 ++;
                                                       out_1 = & outfile_1;                                                       
                                                       }
                  
                  
                  seq_pair.Out_put(label, out_1, NULL, _out_format);
                  
                  }
                                     
    outfile_1.close();
    outfile_1.clear();
    
    qual_1.close();
    qual_1.clear();
    
    primer_1.close();
    primer_1.clear();
    
    dup_1.close();
    dup_1.clear();
    
    Output_analysis_report(qual_count_1, primer_count_1, gc_count_1, dup_count_1, out_count_1, -1, -1, -1, -1, -1);
    
    }


int Input_primers(){
    
    //if ((inprimer == "Default") || (inprimer == "default" ))
    //   return Default_primers();
    
    ifstream infile(inprimer.c_str(), ifstream::in);
    if (!infile){
                 
                 cerr << "Open primers file error : " << inprimer << endl;
                 exit(0);
                 
                 }
    
    int count  = 0;
    
    string buffer;
    
    while(getline(infile, buffer) && (count < MAX_PRIMER)){
                         
                         getline(infile, buffer);
                         
                         primers[count] = buffer;
                         
                         count ++;
                         }
    
    return count;
    
    }

#endif
